/**
 * Created by apple on 14-8-15.
 */

cc.BuilderReader.registerController("EKHomeLayer", {
    onDidLoadFromCCB : function() {
    	if(isOpenAnySdk == true){
        var agent = anysdk.AgentManager.getInstance();
        var channelId = agent.getChannelId();
        
        cc.log("channelId " + channelId);

        if (EKCoreManager.getInstance.formOpenAnimation) {
            if (channelId === "000023") {  // 360渠道号：000023
            	cc.log("channelId " + channelId+"jinrujinru");
                EKCoreManager.getInstance.formOpenAnimation = false;
                var user_plugin  = agent.getUserPlugin();
                user_plugin.login();
                user_plugin.setActionListener(this.onUserLogin, this);
            }
        }
    	}
        this.rootNode.schedule(function () {
            var m = EKCoreManager.getInstance();
            m.currentReminderTickingTime++;
            cc.log(m.currentReminderTickingTime);
            var remindTimekey = "remindTime";
            var remindTimeNum = parseInt(cc.sys.localStorage.getItem(remindTimekey));
            var remindTime;
            if (remindTimeNum == 0) {
                remindTime = 10 * 60;
            } else if (remindTimeNum == 2) {
                remindTime = 30 * 60;
            } else {
                remindTime = 20 * 60;
            }
            if (m.currentReminderTickingTime == remindTime) {
                m.currentReminderTickingTime = 0;
                m.showGuideWithSoundFiles();
            }
        }, 1);

        var self = this;
        var winSize = cc.director.getWinSize();
        cc.audioEngine.stopMusic(true);
        cc.audioEngine.stopAllEffects();

        if (EKCoreManager.getInstance().getSettingsMultiLang() === 1 && isLangCN()) {
            cc.audioEngine.playEffect("sounds/progressSounds/app_name_zh_cn.mp3");
            this.rootNode.getChildByTag(12).setVisible(false);
        } else {
            cc.audioEngine.playEffect("sounds/progressSounds/app_name_en.mp3");
            this.rootNode.getChildByTag(11).setVisible(false);
        }

        cc.audioEngine.playMusic("sounds/bgm_home.mp3", true);

        if (winSize.width/winSize.height >= 1.77) {
            this.enterButton.y = this.enterButton.y * 0.95;
            this.rootNode.getChildByTag(12).setScale(0.9);
            this.rootNode.getChildByTag(11).setScale(0.9);
            this.enterButton.runAction(cc.sequence(
                cc.scaleTo(0.8, 1),
                cc.scaleTo(0.8, 0.9)
            ).repeatForever());
        } else {
            this.enterButton.runAction(cc.sequence(
                cc.scaleTo(0.8, 1.1),
                cc.scaleTo(0.8, 1)
            ).repeatForever());
        }


        this.rootNode.scheduleOnce(function () {
            self.firstEnter();
        }, 0.5);

        if (winSize.width/winSize.height > 1.77) {
            this.parentButton.x = winSize.width * 0.06;
            this.parentButton.y = winSize.height * 0.884;
        }

        if (cc.sys.os === cc.sys.OS_ANDROID) {
            cc.eventManager.addListener({
                event: cc.EventListener.KEYBOARD,
                onKeyReleased: function (keyCode, event) {
                    if (keyCode == cc.KEY.back) {
                        if (!self.canEnd) {
                            jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "showToast", "(Ljava/lang/String;)V", "再次点击返回键退出应用");
                            self.canEnd = true;
                            self.rootNode.scheduleOnce(function () {
                                self.canEnd = false;
                            }, 2);
                        } else {
                            cc.director.end();
                        }
                    }
                }
            }, this.rootNode);
        }
     

       
        //this.setupNewgift();
        this.setupMiliButton(); 
        this.setupMoreApps();    
        if(isOpenAnySdk == true){
        	var agent = anysdk.AgentManager.getInstance();
        	var analytics_plugin = agent.getAnalyticsPlugin();
        	analytics_plugin.logEvent("goshop_test");

        }
//        EKCoreManager.getInstance().eventUmeng("goshop_test");
//        EKCoreManager.getInstance().eventUmeng("goshop_test");
//        EKCoreManager.getInstance().eventUmeng("goshop_test");
//        EKCoreManager.getInstance().eventUmeng("goshop_test");
        
//        this.debug1();
//        this.debug2();
    },
    onUserLogin : function(plugin, code, msg){
        cc.log("on user result action.");
        cc.log("msg:"+msg);
        cc.log("code:"+code);
        cc.log("plugin:"+plugin);
        var kInitSuccess = 0,		/**< enum value is callback of succeeding in initing sdk. */
            kInitFail = 1,		/**< enum  value is callback of failing to init sdk. */
            kLoginSuccess = 2,	/**< enum value is callback of succeeding in login.*/
            kLoginNetworkError = 3,	/**< enum value is callback of network error*/
            kLoginNoNeed = 4,		/**< enum value is callback of no need login.*/
            kLoginFail = 5,		/**< enum value is callback of failing to login. */
            kLoginCancel = 6,		/**< enum value is callback of canceling to login. */
            kLogoutSuccess = 7,	/**< enum value is callback of succeeding in logout. */
            kLogoutFail = 8,		/**< enum value is callback of failing to logout. */
            kPlatformEnter = 9,	/**< enum value is callback after enter platform. */
            kPlatformBack = 10,	/**< enum value is callback after exit antiAddiction. */
            kPausePage = 11,		/**< enum value is callback after exit pause page. */
            kExitPage = 12,		/**< enum value is callback after exit exit page. */
            kAntiAddictionQuery = 13,	/**< enum value is callback after querying antiAddiction. */
            kRealNameRegister = 14,	/**< enum value is callback after registering realname. */
            kAccountSwitchSuccess = 15,	/**< enum alue is callback of succeeding in switching account. */
            kAccountSwitchFail = 16;

        switch(code) {
            case kInitSuccess:
                cc.log("kInitSuccess " + kInitSuccess);
                break;
            case kLoginSuccess:
                cc.log("kLoginSuccess " + kLoginSuccess);
                break;
        }
    },

    debug1 : function () {
        var winSize = cc.director.getWinSize();
        var button = new ccui.Button();
        button.setTouchEnabled(true);
        button.setTitleText("测试模式：购买全部课程");
        button.x = winSize.width * 0.2;
        button.y = winSize.height * 0.2;
        button.addTouchEventListener(this.buyAll, this);
        this.rootNode.addChild(button, ZOrder_UI);
    },
    buyAll : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                var key = "purchased";
                var level = cc.sys.localStorage.getItem(key);
                if (!level || level.indexOf(",") === -1) {
                    level = "0,0";
                }
                level = "15, 0";
                cc.sys.localStorage.setItem(key, level);
                break;
            default :
                break;
        }
    },
    debug2 : function () {
        var winSize = cc.director.getWinSize();
        var button = new ccui.Button();
        button.setTouchEnabled(true);

        button.setTitleText("测试模式：解锁全部课程");
        button.x = winSize.width * 0.2;
        button.y = winSize.height * 0.1;
        button.addTouchEventListener(this.unlockAll, this);
        this.rootNode.addChild(button, ZOrder_UI);
    },
    unlockAll : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                EKCoreManager.getInstance().unlockToLevelAndSubLevel(14, 0);
                break;
            default :
                break;
        }
    },

    "parentButtonTapped" : function(sender,controlEvent) {
        cc.audioEngine.playEffect("sounds/effect/sounds_of_click_button.mp3");
        this.gotoParent();
    },
    "startButtonTapped" : function(sender,controlEvent) {
        cc.audioEngine.playEffect("sounds/effect/sounds_of_click_button.mp3");
        EKCoreManager.getInstance().isFromHome = true;
        EKCoreManager.getInstance().gotoMap();
    },
    //新年红包（过了新年就不用了）
    setupNewgift: function () {
    	var chunjieGift = sys.localStorage.getItem("chunjieGift");
    	if (!chunjieGift) {
    	
    	var winSize = cc.director.getWinSize();
    	// Create the button
    	this.giftButton = new ccui.Button();
    	this.giftButton.setTouchEnabled(true);
    	this.giftButton.loadTextures("all_Ui/newyearbag.png", "all_Ui/newyearbag.png", "");
    	this.giftButton.x = winSize.width * 0.13;
    	this.giftButton.y = winSize.height * 0.2;
    	this.giftButton.addTouchEventListener(this.getGift, this);
    	this.rootNode.addChild( this.giftButton,5);
    	
    	
    	this.giftButton.runAction(cc.repeatForever(cc.sequence(
    			
    			cc.rotateTo(0.15,10),
                 cc.rotateTo(0.3,-10),
                cc.rotateTo(0.3,10),
                cc.rotateTo(0.3,-10),
                cc.rotateTo(0.3,10),
             cc.rotateTo(0.15,0),
    			cc.delayTime(2)
    			
    	)));
    	
   
    	}
    },
    getGift: function () {
    
    	var chunjieGift = sys.localStorage.getItem("chunjieGift");
    	if (!chunjieGift) {
    		chunjieGift = true;
    		sys.localStorage.setItem("chunjieGift", chunjieGift);
    		var chunJieReward = 50;
    		EKCoreManager.getInstance().addMiCoinToUser(chunJieReward);
    		var that = this;
    		that.giftButton.removeFromParent(true);
    		var message = "新春红包50米粒已经到您帐中啦！关注公众号“汉字王国”还能拿更多哦！";
    		this.refreshMiliButton();
    		var alertWindow = new EKAlertWindow(message, 18, 0, this, function () {
    			

    		});
    		this.rootNode.addChild(alertWindow,101);
    	}
    },

    setupMiliButton : function () {
        cc.log("setupMiCoinButton");
        var winSize = cc.director.getWinSize();
        // Create the button
        this.miliButton = new ccui.Button();
        this.miliButton.setTouchEnabled(true);
        this.miliButton.loadTextures("all_Ui/ui_coin_box.png", "all_Ui/ui_coin_box.png", "");
        this.miliButton.x = winSize.width * 0.236;
        this.miliButton.y = winSize.height * 0.884;
        this.miliButton.addTouchEventListener(this.miCoinButtonTouchEvent, this);
        this.rootNode.addChild( this.miliButton , ZOrder_UI);

        this.refreshMiliButton();
    },
    refreshMiliButton : function() {
        var winSize = cc.director.getWinSize();
        var buttonSize = this.miliButton.getContentSize();
        if (this.coin) {
            this.coin.removeFromParent(true);
        }
        this.coin = new ccui.Text();
        var coinText = cc.sys.localStorage.getItem("MyCoin") || 0;
        this.coin.setString(coinText);

        this.coin.setTextAreaSize(cc.size(buttonSize.width/3, buttonSize.height*2/3));
        this.coin.ignoreContentAdaptWithSize(false);
        this.coin.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_RIGHT);

        this.coin.setFontSize(13);
        this.coin.setColor(cc.color.WHITE);
        this.coin.setPosition(cc.p(buttonSize.width/2-11, buttonSize.height*0.5));
        this.miliButton.addChild(this.coin);
    },
    miCoinButtonTouchEvent : function (sender, type) {
        switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
                EKCoreManager.getInstance().isFromHomeToShop = true;
                EKCoreManager.getInstance().isShowMiCoinLayer = true;
                EKCoreManager.getInstance().gotoShop();
                if(isOpenAnySdk == true){
                var agent = anysdk.AgentManager.getInstance();
                var analytics_plugin = agent.getAnalyticsPlugin();
                analytics_plugin.logEvent("Will enter Shop from Home Page");
                }
                break;
            default:
                break;
        }
    },

    //更多王国按钮
    setupMoreApps : function () {
        var self = this;
        var winSize = cc.director.getWinSize();
        var moreAppbutton = new ccui.Button();
        moreAppbutton.setTouchEnabled(true);
        moreAppbutton.loadTextures("all_Ui/ui_more.png", "all_Ui/ui_more.png", "all_Ui/ui_more.png");
        this.rootNode.addChild(moreAppbutton, ZOrder_UI);
        moreAppbutton.setAnchorPoint(1, 0);
        
   
        

        if (winSize.width/winSize.height>1.77) {
            moreAppbutton.setPosition(winSize.width, winSize.height*0.75);
        } else {
            moreAppbutton.setPosition(winSize.width, winSize.height*0.83);
        }


        moreAppbutton.addTouchEventListener(this.moreAppbuttonTouchEvent, this);


        this.moreAppbutton = moreAppbutton;

        var app = new ccui.ImageView();
        app.loadTexture("all_Ui/math_icon.png");
        moreAppbutton.addChild(app);
        var size = moreAppbutton.getContentSize();
        app.setPosition(size.width/2+3, 110);
        app.setTouchEnabled(true);
        app.setScale(0.78);
        app.addTouchEventListener(this.gotoDownloadShuxuewangguo, this);
        
        var app2 = new ccui.ImageView();
        app2.loadTexture("all_Ui/hanzi_icon.png");
        moreAppbutton.addChild(app2);
        var size = moreAppbutton.getContentSize();
        app2.setPosition(size.width/2+3, 175);
        app2.setTouchEnabled(true);
        app2.setScale(0.78);
        app2.addTouchEventListener(this.gotoDownloadHanziwangguo, this);
        

        var listView = new ccui.ListView();
        listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        listView.setTouchEnabled(true);
        listView.setBounceEnabled(true);
        listView.setContentSize(cc.size(240, 130));

        var self = this;
        var moreAppsItem = AV.Object.extend("MoreApps");
        var query = new AV.Query(moreAppsItem);
        query.ascending("index");
        query.find({
            success: function(results) {
                cc.log("Successfully retrieved " + results.length + " scores.");
                // Do something with the returned AV.Object values
                self.hasMoreApps = true;
            },
            error: function(error) {
                cc.log("Error: " + error.code + " " + error.message);
            }
        });
    },
    
    //
    gotoDownloadHanziwangguo : function (sender, type) 
    {
    	switch (type) {
    	case ccui.Widget.TOUCH_BEGAN:
    		break;
    	case ccui.Widget.TOUCH_ENDED:
	  		var winSize = cc.director.getWinSize();
	  		var parentLock = new EKParentLock( function () {
	  		parentLock.removeFromParent(true);
	
		  		if(isOpenAnySdk == true)
		  		{
			  		var agent = anysdk.AgentManager.getInstance();
			  		var channelId = agent.getChannelId();
			  		if (channelId === "000023")
			  		{
			  			jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "jumpTo360AppMarketOfHanziWangguo", "(Ljava/lang/String;)V","cc.morechinese.MMProjectJS");
			  		} 
			  		else
			  		{
			  			jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "jumpToAppMarketOfHanziWangguo", "(Ljava/lang/String;)V","cc.morechinese.MMProjectJS");
			  		}
		  		}
	  		});
	  		this.rootNode.addChild(parentLock, 150);
	  		
    		break;
    	case ccui.Widget.TOUCH_CANCELED:
    		break;
    	default :
    		break;
    	}
    	


    },
   
   //数学王国
    gotoDownloadShuxuewangguo : function (sender, type)
    {
    	switch (type) {
	    	case ccui.Widget.TOUCH_BEGAN:
	    		break;
	    	case ccui.Widget.TOUCH_ENDED:
	    		var winSize = cc.director.getWinSize();
	    		var parentLock = new EKParentLock( function () {
	    			parentLock.removeFromParent(true);
	
	    			if(isOpenAnySdk == true)
	    			{
	    				var agent = anysdk.AgentManager.getInstance();
	    				var channelId = agent.getChannelId();
	    				if (channelId === "000023")
	    				{
	    					jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "jumpTo360AppMarketOfHanziWangguo", "(Ljava/lang/String;)V","cc.morechinese.MathKingdom");
	    				} 
	    				else
	    				{
	    					jsb.reflection.callStaticMethod("org/cocos2dx/javascript/AppActivity", "jumpToAppMarketOfHanziWangguo", "(Ljava/lang/String;)V","cc.morechinese.MathKingdom");
	    				}
	    			}
	    		});
	    		this.rootNode.addChild(parentLock, 150);
	
	    		break;
	    	case ccui.Widget.TOUCH_CANCELED:
	    		break;
	    	default :
	    		break;

    	}
    },
    

    
    //更多王国按钮事件
    moreAppbuttonTouchEvent : function (sender, type) {
        if (this.hasMoreApps) {
            cc.log("123");
            var self = this;
            var winSize = cc.director.getWinSize();
            
            
            switch (type) {
            case ccui.Widget.TOUCH_BEGAN:
            	sender.setScale(1.05);
            	break;
            case ccui.Widget.TOUCH_ENDED:
            	sender.setScale(1);
            	if(isOpenAnySdk == true){
            		var agent = anysdk.AgentManager.getInstance();
            		var analytics_plugin = agent.getAnalyticsPlugin();
            		analytics_plugin.logEvent("Click More App");
            	}
            	cc.audioEngine.playEffect("sounds/effect/sounds_of_click_button.mp3");
            	//没有下拉显示更多app
            	if (!this.moreIsDown)
            	{
            		this.moreIsDown = true;
            		this.moreAppbutton.stopAllActions();

          		if (winSize.width/winSize.height > 1.77) {
          		pos = cc.p(winSize.width, winSize.height*0.28);
          		}
          		else   if (winSize.width/winSize.height > 1.65) {
          		pos = cc.p(winSize.width, winSize.height*0.3);
          		}
          		else {
          		pos = cc.p(winSize.width, winSize.height*0.4);
          		}
            		//andy changed logic
            		self.moreAppbutton.runAction(
            				cc.moveTo(0.5, pos).easing(cc.easeBackIn()));
            		
//            		var parentLock = new EKParentLock( function () {
//            			parentLock.removeFromParent(true);
//            			if (winSize.width/winSize.height > 1.77) {
//            				pos = cc.p(winSize.width, winSize.height*0.28);
//            			}
//            			else   if (winSize.width/winSize.height > 1.65) {
//            				pos = cc.p(winSize.width, winSize.height*0.3);
//            			}
//            			else {
//            				pos = cc.p(winSize.width, winSize.height*0.4);
//            			}
//
//            			self.moreAppbutton.runAction(
//            					cc.moveTo(0.5, pos).easing(cc.easeBackIn())
//            			);
//            		});
//            		this.rootNode.addChild(parentLock, 150);

            	} 
            	else 
            	{
            		this.moreIsDown = false;
            		this.moreAppbutton.stopAllActions();
            		var pos;
            		if (winSize.width/winSize.height > 1.77) {
            			pos = cc.p(winSize.width, winSize.height*0.75);
            		} else {
            			pos = cc.p(winSize.width, winSize.height*0.83);
            		}

            		this.moreAppbutton.runAction(
            				cc.moveTo(0.5, pos).easing(cc.easeBackIn())
            		);
            	}
            	break;
            case ccui.Widget.TOUCH_CANCELED:
            	sender.setScale(1);
            	break;
            default :
            	break;
            }
        }
    },

    firstEnter : function () {
        var isFirstEnter = cc.sys.localStorage.getItem("isFirstEnter");
        if (!isFirstEnter) 
        {
        	//见面礼
            var message = "  10米粒见面礼已经入账，欢迎来到英语王国的世界！";
            var firstAward = new EKAlertWindow(message, 18, 0, this, function () {
            	
                firstAward.removeFromParent(true);
            });
            this.rootNode.addChild(firstAward, ZOrder_UI+1);
            firstAward.setScale(1);
//            firstAward.runAction(
//                cc.scaleTo(0.3, 1)
//            );

            var award = 10;
            EKCoreManager.getInstance().addMiCoinToUser(award);

            this.miliButton.runAction(cc.sequence(
                cc.scaleTo(0.2, 1.05),
                cc.scaleTo(0.2, 1).easing(cc.easeBackOut())
            ));
            this.refreshMiliButton();

            cc.sys.localStorage.setItem("isFirstEnter", true);
            
            cc.sys.localStorage.setItem("newContentWasCame", true); //不在提示内容更新
        }
        else
        {
        	//新内容提示
        	var isNewContentTip = cc.sys.localStorage.getItem("newContentWasCame");
        	if(!isNewContentTip)
        	{
        		cc.sys.localStorage.setItem("newContentWasCame", true);
        		
        		var message = "恭喜您A-Z的课程内容已经更新完成，快来玩吧！";
        		var firstAward = new EKAlertWindow(message, 18, 0, this, function () {

        			firstAward.removeFromParent(true);
        		});
        		this.rootNode.addChild(firstAward, ZOrder_UI+1);
        		firstAward.setScale(1);
        	}
        }
    },

    gotoParent : function() {
        EKCoreManager.getInstance().gotoParentMain();
    },
    "writeLetterButtonTapped" : function(sender,controlEvent) {

    },
    onExit : function () {
        this._super();
        cc.log("onExit");
    }
});