/**
 * Created by bran on 14-9-1.
 */

cc.BuilderReader.registerController("ObjectNode", {
    constructor : function () {
        cc.log(this + " " + this.rootNode);
    }
});

cc.BuilderReader.registerController("EKLogoOpenAnimationLayer", {
    onDidLoadFromCCB : function () {
        var self = this;

        EKCoreManager.getInstance.formOpenAnimation = true;

        cc.Loader.preload([
            "sounds/progressSounds/kaichangdonghua_1.mp3",
            "sounds/progressSounds/kaichangdonghua_2.mp3",
        ], function(){}, this);

        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                EKCoreManager.getInstance().gotoHome();
                return false;
            }
        });
        cc.eventManager.addListener(listener, this.rootNode);

        this.rootNode.scheduleOnce(function(){
            self.onBegin();
        }, 0);

        EKCoreManager.getInstance().refreshOnlineProducts();

        cc.Loader.preload(["sounds/progressSounds/game_xiezimu.mp3",
            "sounds/progressSounds/game_pindanci.mp3",
            "sounds/progressSounds/game_dashengdu.mp3",
            "sounds/progressSounds/game_juxing.mp3",
            "sounds/bgm_home.mp3",
            "sounds/bgm_pindanci.mp3",
            "sounds/bgm_dashengdu.mp3",
            "sounds/bgm_big_map.mp3",
            "sounds/bgm_xiezimu.mp3",
            "sounds/progressSounds/game_pindanci.mp3"], function(){}, this);
    },

    onBegin : function () {
        var self = this;
        this.mina = this.rootNode.getChildByTag(5).getChildByTag(101);
        this.miya = this.rootNode.getChildByTag(6).getChildByTag(101);

        this.mina.animationManager.runAnimationsForSequenceNamed("run");
        this.miya.animationManager.runAnimationsForSequenceNamed("run");
        this.rootNode.scheduleOnce(function () {
            self.miya.animationManager.runAnimationsForSequenceNamed("jump");
        }, 11.3);
        this.rootNode.scheduleOnce(function () {
            self.mina.animationManager.runAnimationsForSequenceNamed("jump");
        }, 11.7);

        this.rootNode.scheduleOnce(function () {
            cc.audioEngine.playMusic("sounds/progressSounds/ani_bgm.mp3");
        }, 3);
    }
});