/**
 * Created by apple on 14-8-23.
 */

var isLangCN = function() {
    var language = cc.sys.language;
//    return language === cc.sys.LANGUAGE_CHINESE;
    return true;
};

var isLangEN = function() {
    var language = cc.sys.language;
    return language === cc.sys.LANGUAGE_ENGLISH;
};

var postToAvos = function(aClass, jsonData) {
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.setRequestHeader("X-AVOSCloud-Application-Id", "7oazam0c0hxuhyqhfvv7qp75oqj0050i204zmiiyl7j10dr8");
    xhr.setRequestHeader("X-AVOSCloud-Application-Key", "bbej1agzq8n9allxsf8r318jvht4xc3jor13d8hr8i4mgoim");
    xhr.setRequestHeader("Content-Type", "application/json");
    xhr.open("POST", "https://cn.avoscloud.com/1.1/classes/" + aClass);
    xhr.send(JSON.stringify(jsonData));
};

var CGPointToDegreeA = function (p) {
    var bearingRadians = Math.atan( p.y / p.x );
    var bearingDegrees = bearingRadians * (180 / Math.PI);
    return bearingDegrees;
};

var angleWithStartAndDestinationPoints = function (p1, p2) {
    var angle = CGPointToDegreeA(cc.pSub(p2, p1));
    angle = angle-90;
    angle = -angle;
    return angle;
};

var distancePointToLine = function (p, lineStart, lineEnd) {
    var pProject = getPointCastOnLine(p, lineStart, lineEnd);
    return cc.pDistance(p, pProject);
};

var getPointCastOnLine = function(p, lineStart, lineEnd) {
    var relativeVector1 = cc.pSub(lineStart, lineEnd);
    var relativeVector2 = cc.pSub(p, lineEnd);
    var relativeVector = cc.pProject(relativeVector2, relativeVector1);
    var absoluteVector = cc.pAdd(lineEnd, relativeVector);
    return absoluteVector;
};

var startHintingWithHand = function (fromPos, toPos, node, moveDur) {
    var tracer = cc.Sprite.create("newhand.png");
    tracer.setOpacity(0);
    node.addChild(tracer, 255);
    var s = cc.p(fromPos.x+50, fromPos.y-50);
    var e = cc.p(toPos.x+50, toPos.y-50);
    tracer.setPosition(s);
    tracer.runAction(cc.sequence(
        cc.fadeTo(0.2, 255),
        cc.moveTo(0, s),
        cc.moveTo(moveDur, e),
        cc.fadeTo(0.2, 0),
        cc.moveTo(moveDur, s),
        cc.fadeTo(0.2, 255),
        cc.moveTo(moveDur, e),
        cc.fadeTo(0.2, 0),
        cc.callFunc(function () {
            tracer.removeFromParent()
        })
    ));
};

var runningLayer = function(){
    return cc.director.getRunningScene().getChildren()[0];
};

function compareDate(oldDate) {
    var oldYear = oldDate.getFullYear();
    var oldMonth = oldDate.getMonth();
    var oldDay = oldDate.getDate();

    var today = new Date();

    var newYear = today.getFullYear();
    var newMonth = today.getMonth();
    var newDay = today.getDate();

    if (newYear > oldYear) {
        return true;
    } else if (newMonth > oldMonth) {
        return true;
    } else {
        return newDay > oldDay;
    }
};

var maskWithCircle = function(maskZOrder, isFromClearToBlack, fromPos, toPos, callback) {
    var clip = new cc.ClippingNode();
    var layer = new cc.LayerColor(cc.color.BLACK);
    clip.addChild(layer);
    var circle = cc.Sprite.create("circle.png");
    clip.setStencil(circle);
    clip.setInverted(true);
    clip.setAlphaThreshold(0.1);
    circle.setPosition(fromPos);
    if (isFromClearToBlack) {
        circle.setScale(2);
        circle.runAction(cc.sequence(
            cc.spawn(
                cc.scaleTo(1, 0.3),
                cc.moveTo(1, toPos)
            ),
            cc.delayTime(0.4),
            cc.scaleTo(0.6, 0),
            cc.callFunc(function () {
                callback();
            })
        ))
    } else {
        circle.setScale(0);
        circle.runAction(cc.sequence(
            cc.scaleTo(0.6, 0.3),
            cc.spawn(
                cc.scaleTo(0.6, 2),
                cc.moveTo(1, toPos)
            ),
            cc.callFunc(function () {
                callback();
            })
        ))
    }
    return clip;
};