/**
 * Created by bran on 14/11/7.
 */

var EKParentLock = cc.Layer.extend({
    ctor:function (func) {
        this._super();

        var maskLayout = this.createMask();
        maskLayout.setTouchEnabled(false);
        this.addChild(maskLayout);
        this.setupTips();

        this.maskLayout1 = this.createMask();
        this.maskLayout1.setBackGroundColorOpacity(20);
        this.addChild(this.maskLayout1);
        this.maskLayout1.setTouchEnabled(false);

        this.setupTouchEvent();

        cc.log(func);
        this.func = func;

        cc.audioEngine.playEffect("sounds/progressSounds/parent_gate_zh_cn.mp3");

        return true;
    },
    createMask : function () {
        var winSize = cc.director.getWinSize();
        var maskLayout = new ccui.Layout();
        maskLayout.setContentSize(winSize.width, winSize.height);
        maskLayout.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        maskLayout.setBackGroundColor(cc.color(0, 0, 0));
        maskLayout.setBackGroundColorOpacity(100);
        maskLayout.setTouchEnabled(true);
        return maskLayout;
    },
    setupTips : function () {
        var tip = "只有爸爸妈妈才可以进入哦！请单指右滑解锁进入~";
        var tipsLayer = new EKAlertWindow(tip, 20, 0);
//        tipsLayer.cancelButton2.setEnabled(false);
        this.addChild(tipsLayer);
    },
    setupTouchEvent : function () {
        var self = this;
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,                       // 设置是否吞没事件，在 onTouchBegan 方法返回 true 时吞掉事件，不再向下传递。
            onTouchBegan: function (touch, event) {     //实现 onTouchBegan 事件处理回调函数
                var target = event.getCurrentTarget();  // 获取事件所绑定的 target, 通常是cc.Node及其子类
                this.beginPostion = target.convertToNodeSpace(touch.getLocation());

                return true;
            },
            onTouchMoved: function (touch, event) {

            },
            onTouchEnded: function (touch, event) {         // 实现onTouchEnded事件处理回调函数
                var target = event.getCurrentTarget();
                this.endPosition = target.convertToNodeSpace(touch.getLocation());
                var horizontalDistance = this.endPosition.x - this.beginPostion.x;

                if (horizontalDistance > 30) {
                    self.func();
                } else {
                    self.removeFromParent(true);
                }
            }
        });
        cc.eventManager.addListener(listener, this.maskLayout1);
    }
});